{#-
 #  Jinja2 template for generating server implementation stubs for Legato APIs.
 #
 #  Note: C/C++ comments apply to the generated code.  For example this template itself is not
 #  autogenerated, but the comment is copied verbatim into the generated file when the template is
 #  expanded.
 #
 #  Copyright (C) Sierra Wireless Inc.
 #}
{%- for comment in fileComments -%}
{{comment|FormatHeaderComment}}
{% endfor %}

#include "legato.h"
#include "interfaces.h"

{% for function in functions %}
{%- if function.comment %}
//--------------------------------------------------------------------------------------------------
{{function.comment|FormatHeaderComment}}
//--------------------------------------------------------------------------------------------------
{%- endif %}
{%- if args.async and function is not EventFunction and function is not HasCallbackFunction %}
void {{apiName}}_{{function.name}} (
    {{apiName}}_ServerCmdRef_t _cmdRef
    {%- for parameter in function|CAPIParameters if parameter is InParameter %}{% if loop.first %},{% endif %}
    {{parameter|FormatParameter(forceInput=True)}}{% if not loop.last %},{%endif %} ///< [{{parameter.direction|FormatDirection}}]
             {{-parameter.comments|join("\n///<")|indent(8)}}
    {%- endfor %}
)
{
    // Once processing is finished, call
    /*
    {{apiName}}_{{function.name}}Respond
    (
        {{apiName}}_ServerCmdRef_t _cmdRef
        {%- if function.returnType %},
        {{function.returnType|FormatType}} _result
        {%- endif %}
        {%- for parameter in function|CAPIParameters if parameter is OutParameter %},
        {{parameter|FormatParameterName}}
        {%- endfor %}
    );
    */
}
{%- else %}
{{function.returnType|FormatType}} {{apiName}}_{{function.name}}
(
    {%- for parameter in function|CAPIParameters %}
    {{parameter|FormatParameter}}{% if not loop.last %},{% endif %}
        ///< [{{parameter.direction|FormatDirection}}]
             {{-parameter.comments|join("\n///<")|indent(8)}}
    {%-else%}
    void
    {%-endfor%}
)
{
    {%- if function.returnType %}
    {%- if function.returnType.name == 'le_result_t' %}
    return LE_NOT_IMPLEMENTED;
    {%- else %}
    return {{function.returnType|FormatTypeInitializer}};
    {%- endif %}
    {%- endif %}
}
{%- endif %}
{%- endfor %}
